libdap::ServerFunction Class Reference

## Public Member Functions

virtual bool | canOperateOn (DDS &)
virtual bool | canOperateOn (DMR &)
bool_func | get_bool_func ()
btp_func | get_btp_func ()
D4Function | get_d4_function ()
proj_func | get_proj_func ()
std::string | getDescriptionString ()
std::string | getDocUrl ()
std::string | getName ()
std::string | getRole ()
std::string | getTypeString ()
std::string | getUsageString ()
std::string | getVersion ()
| ServerFunction (std::string name, std::string version, std::string description, std::string usage, std::string doc_url, std::string role, bool_func f)
| ServerFunction (std::string name, std::string version, std::string description, std::string usage, std::string doc_url, std::string role, btp_func f)
| ServerFunction (std::string name, std::string version, std::string description, std::string usage, std::string doc_url, std::string role, D4Function f)
| ServerFunction (std::string name, std::string version, std::string description, std::string usage, std::string doc_url, std::string role, proj_func f)
void | setDescriptionString (const std::string &desc)
void | setDocUrl (const std::string &url)
void | setFunction (bool_func bf)
void | setFunction (btp_func btp)
void | setFunction (D4Function pf)
void | setFunction (proj_func pf)
void | setName (const std::string &n)
void | setRole (const std::string &r)
void | setUsageString (const std::string &u)
void | setVersion (const std::string &ver)

## Detailed Description

Definition at line 42 of file ServerFunction.h.

## Constructor & Destructor Documentation

## ServerFunction() [1/5]

libdap::ServerFunction::ServerFunction | ( |  | ) |

Definition at line 40 of file ServerFunction.cc.

## ServerFunction() [2/5]

libdap::ServerFunction::ServerFunction | ( | std::string | name,
|  | std::string | version,
|  | std::string | description,
|  | std::string | usage,
|  | std::string | doc_url,
|  | std::string | role,
|  | bool_func | f )

Definition at line 48 of file ServerFunction.cc.

## ServerFunction() [3/5]

libdap::ServerFunction::ServerFunction | ( | std::string | name,
|  | std::string | version,
|  | std::string | description,
|  | std::string | usage,
|  | std::string | doc_url,
|  | std::string | role,
|  | btp_func | f )

Definition at line 60 of file ServerFunction.cc.

## ServerFunction() [4/5]

libdap::ServerFunction::ServerFunction | ( | std::string | name,
|  | std::string | version,
|  | std::string | description,
|  | std::string | usage,
|  | std::string | doc_url,
|  | std::string | role,
|  | proj_func | f )

Definition at line 72 of file ServerFunction.cc.

## ServerFunction() [5/5]

libdap::ServerFunction::ServerFunction | ( | std::string | name,
|  | std::string | version,
|  | std::string | description,
|  | std::string | usage,
|  | std::string | doc_url,
|  | std::string | role,
|  | D4Function | f )

Definition at line 84 of file ServerFunction.cc.

## ~ServerFunction()

virtual libdap::ServerFunction::~ServerFunction | ( |  | ) |

inline virtual

Definition at line 71 of file ServerFunction.h.

## Member Function Documentation

## canOperateOn() [1/2]

virtual bool libdap::ServerFunction::canOperateOn | ( | DDS & |  | ) |

inline virtual

If you are writing a function that can only operate on a particular kind of data, or one that relies on the presence of particular metadata, then you might override this method in order to stop the server from advertising the function in conjunction with datasets to which it cannot be applied.

Parameters

  dds

  A DDS object for the dataset about which we will ask the question: Can this function operate on all or some portion of the contents of this dataset? CAUTION: Any implementation of this should be careful not to read data (or read as little as possible) from the passed DDS. Reading data in this method may have negative effect on overall performance. Examining metadata and dataset structure should be the basis for determining the applicability of a function to the dataset.

Returns
  true If this function operate on all or some portion of the contents of this dataset, false otherwise.

Definition at line 103 of file ServerFunction.h.

## canOperateOn() [2/2]

virtual bool libdap::ServerFunction::canOperateOn | ( | DMR & |  | ) |

inline virtual

See also
  canOperateOn(DDS &)

Parameters

  The | Dataset's DMR.

Returns
  True if the function can work with the dataset, false otherwise.

Definition at line 110 of file ServerFunction.h.

## get_bool_func()

bool_func libdap::ServerFunction::get_bool_func | ( |  | ) |

inline

Definition at line 140 of file ServerFunction.h.

## get_btp_func()

btp_func libdap::ServerFunction::get_btp_func | ( |  | ) |

inline

Definition at line 141 of file ServerFunction.h.

## get_d4_function()

D4Function libdap::ServerFunction::get_d4_function | ( |  | ) |

inline

Definition at line 143 of file ServerFunction.h.

## get_proj_func()

proj_func libdap::ServerFunction::get_proj_func | ( |  | ) |

inline

Definition at line 142 of file ServerFunction.h.

## getDescriptionString()

std::string libdap::ServerFunction::getDescriptionString | ( |  | ) |

inline

Definition at line 85 of file ServerFunction.h.

## getDocUrl()

std::string libdap::ServerFunction::getDocUrl | ( |  | ) |

inline

Definition at line 79 of file ServerFunction.h.

## getName()

std::string libdap::ServerFunction::getName | ( |  | ) |

inline

Definition at line 73 of file ServerFunction.h.

## getRole()

std::string libdap::ServerFunction::getRole | ( |  | ) |

inline

Definition at line 82 of file ServerFunction.h.

## getTypeString()

std::string libdap::ServerFunction::getTypeString | ( |  | ) |

inline

Definition at line 128 of file ServerFunction.h.

## getUsageString()

std::string libdap::ServerFunction::getUsageString | ( |  | ) |

inline

Definition at line 76 of file ServerFunction.h.

## getVersion()

std::string libdap::ServerFunction::getVersion | ( |  | ) |

inline

Definition at line 88 of file ServerFunction.h.

## setDescriptionString()

void libdap::ServerFunction::setDescriptionString | ( | const std::string & | desc | ) |

inline

Definition at line 86 of file ServerFunction.h.

## setDocUrl()

void libdap::ServerFunction::setDocUrl | ( | const std::string & | url | ) |

inline

Definition at line 80 of file ServerFunction.h.

## setFunction() [1/4]

void libdap::ServerFunction::setFunction | ( | bool_func | bf | ) |

inline

Set the C function pointer for this function object.

Note
  This does not alter any of the other function pointers, so the same name can be used for all four different kinds of functions without conflict.

Parameters

  bf |

Definition at line 120 of file ServerFunction.h.

## setFunction() [2/4]

void libdap::ServerFunction::setFunction | ( | btp_func | btp | ) |

inline

Definition at line 122 of file ServerFunction.h.

## setFunction() [3/4]

void libdap::ServerFunction::setFunction | ( | D4Function | pf | ) |

inline

Definition at line 126 of file ServerFunction.h.

## setFunction() [4/4]

void libdap::ServerFunction::setFunction | ( | proj_func | pf | ) |

inline

Definition at line 124 of file ServerFunction.h.

## setName()

void libdap::ServerFunction::setName | ( | const std::string & | n | ) |

inline

Definition at line 74 of file ServerFunction.h.

## setRole()

void libdap::ServerFunction::setRole | ( | const std::string & | r | ) |

inline

Definition at line 83 of file ServerFunction.h.

## setUsageString()

void libdap::ServerFunction::setUsageString | ( | const std::string & | u | ) |

inline

Definition at line 77 of file ServerFunction.h.

## setVersion()

void libdap::ServerFunction::setVersion | ( | const std::string & | ver | ) |

inline

Definition at line 89 of file ServerFunction.h.

The documentation for this class was generated from the following files:

- ServerFunction.h
- ServerFunction.cc